--- Makefile.org	Sun May 20 22:31:46 2001
+++ Makefile	Mon May 21 23:18:54 2001
@@ -16,7 +16,10 @@
 #XINERAMA_LIBS = -lXinerama -lXext
 
 PREFIX = /usr/local
-X11DIR = /usr/X11R6
+#X11DIR = /usr/X11R6
+X11DIR = /XFree86
+OS2EXE =
+OS2BIND =
 
 CC     = gcc
 COFLAGS = -funroll-loops -fexpensive-optimizations -ffast-math -fomit-frame-pointer -frerun-cse-after-loop
@@ -25,7 +28,8 @@
 INSTALL= install -m 755 -s
 INSTALLMAN= install -m 644 
 
-OS = $(shell uname -s)
+#OS = $(shell uname -s)
+OS = OS2
 
 # add system dependent libs etc
 ifeq "$(OS)" "UnixWare"
@@ -41,6 +45,12 @@
 CFLAGS += -I /usr/include/X11
 LDFLAGS += -L /usr/lib/X11
 endif
+ifeq "$(OS)" "OS2"
+LDFLAGS += -lsocket
+CFLAGS += -Zcrtdll -Zmtd -D__ST_MT__ERRNO__
+OS2EXE = rdesktop.exe
+OS2BIND = emxbind -b -w rdesktop
+endif
 
 HAVE_GETOPT = 0
 
@@ -66,12 +76,13 @@
 
 rdesktop: $(GNUOBJ) $(CRYPTOBJ) $(RDPOBJ)
 	$(CC) $(CFLAGS) -o rdesktop $(RDPOBJ) $(CRYPTOBJ) $(GNUOBJ) $(LDFLAGS)
+	$(OS2BIND)
 
 proto:
 	cproto -DMAKE_PROTO -o proto.h *.c
 
 clean:
-	rm -f *.o crypto/*.o gnu/*.o *~ *.out rdesktop core
+	rm -f *.o crypto/*.o gnu/*.o *~ *.out rdesktop core $(OS2EXE)
 
 #genkb: genkb.o
 #	$(CC) $(CFLAGS) -o genkb $(LDFLAGS) genkb.o
--- rdesktop.h.org	Sun May 20 22:31:48 2001
+++ rdesktop.h	Tue May 22 13:07:46 2001
@@ -91,3 +91,9 @@
 #define xfree(mem) xfree2(__LINE__, ##__FILE__, mem)
 #endif
 
+#ifdef __EMX__
+#define strcasecmp stricmp
+#define strncasecmp strnicmp
+#include <sys/select.h>
+unsigned long DosError (unsigned long ulError);
+#endif
--- rdesktop.c.org	Sun May 20 22:31:48 2001
+++ rdesktop.c	Tue May 22 12:52:42 2001
@@ -27,6 +27,11 @@
 #endif
 #include <fcntl.h>		/* open */
 #include <pwd.h>		/* getpwuid */
+#ifdef __EMX__
+#include <sys/types.h>		/* required by stat.h */
+#include <netdb.h>		/* gethostname */
+#include <termios.h>
+#endif
 #include <sys/stat.h>		/* stat */
 #include <sys/time.h>		/* gettimeofday */
 #include <sys/times.h>		/* times */
@@ -156,6 +161,9 @@
   int option_index = 0;
 
 
+#ifdef __EMX__
+  DosError(0L); /* Suppress annoying popup error windows. */
+#endif
   STATUS ("rdesktop: A Remote Desktop Protocol client.\n");
   STATUS ("Version " VERSION ". Copyright (C) 1999-2000 Matt Chapman.\n");
   STATUS ("See http://www.rdesktop.org/ for more information.\n\n");
@@ -185,7 +193,22 @@
 	    if (isatty (fileno (stdin)))
 	    {
 	      char *pw;
+#ifdef __EMX__
+              struct termios termios;
+
+              if (!tcgetattr(STDIN_FILENO,&termios))
+              {
+                tcflag_t lflag=termios.c_lflag;
+                termios.c_lflag&=~ECHO;
+                tcsetattr(STDIN_FILENO,TCSANOW,&termios);
+                pw = _getpass2("Password: ",0);
+                termios.c_lflag=lflag;
+                tcsetattr(STDIN_FILENO,TCSANOW,&termios);
+              } else
+                pw =_getpass2("Password: ",0);
+#else
               pw = getpass("Password: ");
+#endif
 	      strncpy (password, pw, sizeof (password));
 	    } else {
 	      if (fgets ((char *)&password, sizeof (password), stdin) == NULL)
--- tcp.c.org	Sun May 20 22:31:48 2001
+++ tcp.c	Tue May 22 00:34:36 2001
@@ -19,6 +19,9 @@
 */
 
 #include <unistd.h>		/* select read write close */
+#ifdef __EMX__
+#include <sys/types.h>		/* required by socket.h */
+#endif
 #include <sys/socket.h>		/* socket connect setsockopt */
 #include <sys/time.h>		/* timeval */
 #include <netdb.h>		/* gethostbyname */
--- gnu\getopt.c.org	Sun May 20 22:31:48 2001
+++ gnu\getopt.c	Mon May 21 00:05:06 2001
@@ -76,6 +76,10 @@
 #endif
 #endif
 
+#ifdef __EMX__
+#include <string.h>
+#endif
+
 #if defined (WIN32) && !defined (__CYGWIN32__)
 /* It's not Unix, really.  See?  Capital letters.  */
 #include <windows.h>
